OBJ_MONITOR_XLIB= ../monitor/monitor.o ../monitor/conectar.o ../monitor/socket.o ../monitor/ven-xlib.o
OBJ_MONITOR_XT= ../monitor/monitor.o ../monitor/conectar.o ../monitor/socket.o ../monitor/ven-xt.o
DEFS_MONITOR= ../monitor/global.hpp ../monitor/monitor.hpp ../monitor/ventana.hpp

MONITOR_XLIB: $(OBJ_MONITOR_XLIB)
	$(CC) $(OBJ_MONITOR_XLIB) -o $(MONITOR_EXE_XLIB) $(LIBS_XLIB)
	chmod 755 $(MONITOR_EXE_XLIB)

MONITOR_XT: $(OBJ_MONITOR_XT)
	$(CC) $(OBJ_MONITOR_XT) -o $(MONITOR_EXE_XT) $(LIBS_XT)
	chmod 755 $(MONITOR_EXE_XT)

../monitor/monitor.o: ../monitor/monitor.C $(DEFS_MONITOR)
	$(CC) -c ../monitor/monitor.C $(INCLUDES) -o ../monitor/monitor.o

../monitor/conectar.o: ../monitor/conectar.C $(DEFS_MONITOR)
	$(CC) -c ../monitor/conectar.C $(INCLUDES) -o ../monitor/conectar.o

../monitor/socket.o: ../monitor/socket.C $(DEFS_MONITOR)
	$(CC) -c ../monitor/socket.C $(INCLUDES) -o ../monitor/socket.o

../monitor/ven-xlib.o: ../monitor/ven-xlib.C $(DEFS_MONITOR)
	$(CC) -c ../monitor/ven-xlib.C $(INCLUDES) -o ../monitor/ven-xlib.o

../monitor/ven-xt.o: ../monitor/ven-xt.C $(DEFS_MONITOR)
	$(CC) -c ../monitor/ven-xt.C $(INCLUDES) -o ../monitor/ven-xt.o


