/*       FIGURA              Ignacio  Merino  Lagunilla                       */

#include <math.h>
#include <ctype.h>
#include <string.h>
#include <stdlib.h>
#include "global.hpp"

//#define 	DEBUG


int figura::crear(char *f_fig)
{
 FILE *fig;
 char linea[100];
 int x1 , x2 , y1 , y2 , a , c , j;
 float ang , an;
 register unsigned char i;
 figura *pfigura;
 punto_pol *p;

	printf("Fichero de descripcion del mundo: ");
	scanf("%s" , f_fig);
	if ( (fig = fopen(f_fig , "rt") ) == NULL)
	{
		printf("\aERROR: No puedo habrir el fichero '%s'.\n" , f_fig);
		if (fichero == CIERTO) fprintf(accion , "ERROR: No puedo habrir el fichero '%s'.\n" , f_fig);
		return (-1);
	}
#ifdef DEBUG
	printf("Abro el fichero de figuras '%s'\n" , f_fig);
	if (fichero == CIERTO) fprintf(accion , "Abro el fichero de figuras '%s'\n" , f_fig);
#endif
	while( !feof(fig) )
	{
		i = 0; while( isalpha(linea[i++] = fgetc(fig)) ); linea[--i] = '\0';
		if( strcmp(linea , "C") == 0)
		{
			while( (c = fgetc(fig) ) != '\n');
#ifdef DEBUG
			printf("Leo una linea de comentario\n");
			if (fichero == CIERTO) fprintf(accion , "Leo una linea de comentario\n");
#endif
		}
		else if( strcmp(linea , "mapa") == 0)
		{
			i = 0; while( isdigit(linea[i++] = fgetc(fig)) ); linea[--i] = '\0';
			x1 = atoi(linea);
			i = 0; while( isdigit(linea[i++] = fgetc(fig)) ); linea[--i] = '\0';
			y1 = atoi(linea);
			planox = x1;
			planoy = y1;
#ifdef DEBUG
			printf("Leo las coordenadas maximas del mapa x = %d y = %d\n" , planox , planoy);
			if (fichero == CIERTO) fprintf(accion , "Leo las coordenadas maximas del mapa x = %d y = %d\n" , planox , planoy);
#endif
		}
		else if( strcmp(linea , "recta") == 0)
		{
			i = 0; while( isdigit(linea[i++] = fgetc(fig)) ); linea[--i] = '\0';
			c = atoi(linea);
			i = 0; while( isdigit(linea[i++] = fgetc(fig)) ); linea[--i] = '\0';
			x1 = atoi(linea);
			i = 0; while( isdigit(linea[i++] = fgetc(fig)) ); linea[--i] = '\0';
			y1 = atoi(linea);
			i = 0; while( isdigit(linea[i++] = fgetc(fig)) ); linea[--i] = '\0';
			x2 = atoi(linea);
			i = 0; while( isdigit(linea[i++] = fgetc(fig)) ); linea[--i] = '\0';
			y2 = atoi(linea);
			if(x2 >= planox || x1 >= planox || y2 >= planoy || y1 >= planoy)
			{
				printf("\aERROR: Recta demasiado grande x1 = %d y1 = %d x2 = %d y2 = %d.\n" , x1 , y1 , x2 , y2);
				if (fichero == CIERTO) fprintf(accion , "ERROR: Recta demasiado grande x1 = %d y1 = %d x2 = %d y2 = %d.\n" , x1 , y1 , x2 , y2);
				fclose(fig);
				return(-2);
			}
			if( (pfigura = new recta(x1 , y1 , x2 , y2 , c)) == NULL)
			{
				printf("\aERROR: No hay memoria suficiente para la recta x1 = %d y1 = %d x2 = %d y2 = %d.\n" , x1 , y1 , x2 , y2);
				if (fichero == CIERTO) fprintf(accion , "ERROR: No hay memoria suficiente para la recta x1 = %d y1 = %d x2 = %d y2 = %d.\n" , x1 , y1 , x2 , y2);
				fclose(fig);
				return(-3);
			}
#ifdef DEBUG
			printf("Creo la recta x1 = %d y1 = %d x2 = %d y2 = %d color %d\n" , x1 , y1 , x2 , y2 , c);
			if (fichero == CIERTO) fprintf(accion , "Creo la recta x1 = %d y1 = %d x2 = %d y2 = %d color %d\n" , x1 , y1 , x2 , y2 , c);
#endif
		}
		else if( strcmp(linea , "circulo") == 0)
		{
			i = 0; while( isdigit(linea[i++] = fgetc(fig)) ); linea[--i] = '\0';
			c = atoi(linea);
			i = 0; while( isdigit(linea[i++] = fgetc(fig)) ); linea[--i] = '\0';
			x1 = atoi(linea);
			i = 0; while( isdigit(linea[i++] = fgetc(fig)) ); linea[--i] = '\0';
			y1 = atoi(linea);
			i = 0; while( isdigit(linea[i++] = fgetc(fig)) ); linea[--i] = '\0';
			a = atoi(linea);
			if(x1 + a >= planox || y1 + a >= planoy)
			{
				printf("\aERROR: Circulo demasiado grande x = %d y = %d radio = %d.\n" , x1 , y1 , a);
				if (fichero == CIERTO) fprintf(accion , "ERROR: Circulo demasiado grande x = %d y = %d radio = %d.\n" , x1 , y1 , a);
				fclose(fig);
				return(-4);
			}
			if( (pfigura = new circulo(x1 , y1 , a , c)) == NULL)
			{
				printf("\aERROR: No hay memoria suficiente para el circulo x = %d y = %d radio = %d.\n" , x1 , y1 , a);
				if (fichero == CIERTO) fprintf(accion , "ERROR: No hay memoria suficiente para el circulo x = %d y = %d radio = %d.\n" , x1 , y1 , a);
				fclose(fig);
				return(-5);
			}
#ifdef DEBUG
			printf("Creo el circulo x = %d y = %d radio = %d color %d\n" , x1 , y1 , a , c);
			if (fichero == CIERTO) fprintf(accion , "Creo el circulo x = %d y = %d radio = %d color %d\n" , x1 , y1 , a , c);
#endif
		}
		else if( strcmp(linea , "poligono") == 0)
		{
			i = 0; while( isdigit(linea[i++] = fgetc(fig)) ); linea[--i] = '\0';
			c = atoi(linea);
			i = 0; while( isdigit(linea[i++] = fgetc(fig)) ); linea[--i] = '\0';
			x1 = atoi(linea);
			i = 0; while( isdigit(linea[i++] = fgetc(fig)) ); linea[--i] = '\0';
			y1 = atoi(linea);
			i = 0; while( isdigit(linea[i++] = fgetc(fig)) ); linea[--i] = '\0';
			ang = radianes( atoi(linea) );
			i = 0; while( isdigit(linea[i++] = fgetc(fig)) ); linea[--i] = '\0';
			a = atoi(linea);
			if( (p = new(punto_pol[a])) == NULL)
			{
				printf("\aERROR: No hay memoria suficiente para los %d puntos del poligono.\n" , a);
				if (fichero == CIERTO) fprintf(accion , "ERROR: No hay memoria suficiente para los %d puntos del poligono.\n" , a);
				fclose(fig);
				return(-6);
			}
			for(j = 0 ; j < a ; j++)
			{
				i = 0; while( isdigit(linea[i++] = fgetc(fig)) ); linea[--i] = '\0';
				x2 = atoi(linea);
				i = 0; while( isdigit(linea[i++] = fgetc(fig)) ); linea[--i] = '\0';
				an = radianes( atoi(linea) );
				p[j].fijar_punto(x2 , an);
				an = angulo(an + ang);
				if(x1 + x2 * cos(an) >= planox || y1 - x2 * sin(an) >= planoy)
				{
					printf("\aERROR: Poligono demasiado grande x = %d y = %d angulo = %d puntos %d.\n" , x1 , y1 , ang , a);
					if (fichero == CIERTO) fprintf(accion , "ERROR: Poligono demasiado grande x = %d y = %d angulo = %d puntos %d.\n" , x1 , y1 , ang , a);
					fclose(fig);
					return(-7);
				}
			}
			if( (pfigura = new poligono(x1 , y1 , ang , a , p , c)) == NULL)
			{
				printf("\aERROR: No hay memoria suficiente para el poligono x = %d y = %d angulo = %d puntos %d.\n" , x1 , y1 , ang , a);
				if (fichero == CIERTO) fprintf(accion , "ERROR: No hay memoria suficiente para el poligono x = %d y = %d angulo = %d puntos %d.\n" , x1 , y1 , ang , a);
				fclose(fig);
				return(-8);
			}
#ifdef DEBUG
			printf("Creo el poligono x = %d y = %d angulo = %d puntos %d color %d\n" , x1 , y1 , grados(ang) , a , c);
			for(j = 0 ; j < a ; j++) printf("punto %d; distancia = %d angulo = %d\n" , j , (int)p[j].di_dis() , grados((int)p[j].di_ang()) );
			if (fichero == CIERTO)
			{
				fprintf(accion , "Creo el poligono x = %d y = %d angulo = %d puntos %d color %d\n" , x1 , y1 , grados(ang) , a , c);
				for(j = 0 ; j < a ; j++) fprintf(accion , "punto %d; distancia=%d angulo=%d\n" , j , (int)p[j].di_dis() , grados(p[j].di_ang()) );
			}
#endif
		}
	}
	fclose(fig);
#ifdef DEBUG
	printf("Creo todas las figuras del mundo\n");
	if (fichero == CIERTO) fprintf(accion , "Creo todas las figuras del mundo\n");
#endif
	return(0);
}

void figura::dibujar_figuras(void)
{
 figura *aux = this;
 int i = 0;

	while(aux != NULL)
	{
		aux->dibujar(aux->di_color());
		aux = aux->sig;
		++i;
	}
#ifdef DEBUG
	printf("Dibujo las %d figuras del mundo\n" , i);
	if (fichero == CIERTO) fprintf(accion , "Dibujo las %d figuras del mundo\n" , i);
#endif
}

recta::recta(int ax , int ay , int bx , int by , int c)
{
	sig = figuras;
	figuras = this;
	a.fijar_punto(ax , ay);
	b.fijar_punto(bx , by);
	color = c;
}

void recta::dibujar(unsigned char color)
{
	mapa->recta((int)a.di_x() , (int)a.di_y() , (int)b.di_x() , (int)b.di_y() , color);
#ifdef DEBUG
	printf("Dibujo la recta; x1 = %d y1 = %d x2 = %d y2 = %d\n" , (int)a.di_x() , (int)a.di_y() , (int)b.di_x() , (int)b.di_y());
	if (fichero == CIERTO) fprintf(accion , "Dibujo la recta; x1 = %d y1 = %d x2 = %d y2 = %d\n" , (int)a.di_x() , (int)a.di_y() , (int)b.di_x() , (int)b.di_y());
#endif
}

poligono::poligono(int cx , int cy , float a , int n , punto_pol *p , int c)
{
	sig = figuras;
	figuras = this;
	n_lados = n;
	centro.fijar_punto(cx , cy);
	angulo = a;
	puntos = p;
	color = c;
}

void poligono::dibujar(unsigned char color)
{
	mapa->poligono((int)centro.di_x() , (int)centro.di_y() , angulo , n_lados , puntos , color);
#ifdef DEBUG
	printf("Dibujo el poligono; x = %d y = %d angulo = %d puntos %d\n" , (int)centro.di_x() , (int)centro.di_y() , grados(angulo) , n_lados);
	if (fichero == CIERTO) fprintf(accion,"Dibujo el poligono; x = %d y = %d angulo = %d puntos %d\n" , (int)centro.di_x() , (int)centro.di_y() , grados(angulo) , n_lados);
#endif
}

circulo::circulo(int x , int y , int a , int c)
{
	sig = figuras;
	figuras = this;
	centro.fijar_punto(x , y);
	radio = a;
	color = c;
}

void circulo::dibujar(unsigned char color)
{
	mapa->circulo((int)centro.di_x() , (int)centro.di_y() , radio , color);
#ifdef DEBUG
	printf("Dibujo el circulo; x = %d y = %d radio = %d\n" , (int)centro.di_x() , (int)centro.di_y() , radio);
	if (fichero == CIERTO) fprintf(accion , "Dibujo el circulo; x = %d y = %d radio = %d\n" , (int)centro.di_x() , (int)centro.di_y() , radio);
#endif
}

void figura::enviar_figuras(int sock , int *accesible)
{
 figura *aux = this;
 int i = 0;

	while(aux != NULL)
	{
		aux->enviar(sock , accesible);
		aux = aux->sig;
		++i;
	}
#ifdef DEBUG
	printf("Envio las %d figuras del mundo por el socket %d\n" , i , sock);
	if (fichero == CIERTO) fprintf(accion , "Envio las %d figuras del mundo por el sock %d\n" , i , sock);
#endif
}

void recta::enviar(int sock , int *accesible)
{
	sprintf(msg_sale , "MFR%.3f %.3f %.3f %.3f %c" , a.di_x() , a.di_y() , b.di_x() , b.di_y() , color);
	enviar_msg(sock , accesible);
#ifdef DEBUG
	printf("Envio la recta; x1 = %d y1 = %d x2 = %d y2 = %d\n" , (int)a.di_x() , (int)a.di_y() , (int)b.di_x() , (int)b.di_y());
	if (fichero == CIERTO) fprintf(accion , "Envio la recta; x1 = %d y1 = %d x2 = %d y2 = %d\n" , (int)a.di_x() , (int)a.di_y() , (int)b.di_x() , (int)b.di_y());
#endif
}

void poligono::enviar(int sock , int *accesible)
{
 float x , y;
 int i;
 float ang , a , b;

	sprintf(msg_sale , "MFP%d %c" , n_lados , color);
	enviar_msg(sock , accesible);
	a = centro.di_x();
	b = centro.di_y();
	for(i = 0 ; i < n_lados ; i++)
	{
		ang = angulo(angulo + puntos[i].di_ang());
		x = a + puntos[i].di_dis() * cos(ang);
		y = b - puntos[i].di_dis() * sin(ang);
		sprintf(msg_sale , "MPP%.3f %.3f" , x , y);
		enviar_msg(sock , accesible);
	}
#ifdef DEBUG
	printf("Envio el poligono; x = %d y = %d angulo = %d puntos %d\n" , (int)centro.di_x() , (int)centro.di_y() , grados(angulo) , n_lados);
	if (fichero == CIERTO) fprintf(accion , "Envio el poligono; x = %d y = %d angulo = %d puntos %d\n" , (int)centro.di_x() , (int)centro.di_y() , grados(angulo) , n_lados);
#endif
}

void circulo::enviar(int sock , int *accesible)
{
	sprintf(msg_sale , "MFC%.3f %.3f %d %c" , centro.di_x() , centro.di_y() , radio , color);
	enviar_msg(sock , accesible);
#ifdef DEBUG
	printf("Dibujo el circulo; x = %d y = %d radio = %d\n" , (int)centro.di_x() , (int)centro.di_y() , radio);
	if (fichero == CIERTO) fprintf(accion , "Dibujo el circulo; x = %d y = %d radio = %d\n" , (int)centro.di_x() , (int)centro.di_y() , radio);
#endif
}

int figura::escribir_figuras(char *fich , int copia)
{
 FILE *fig;
 figura *aux = this;
 int i = 0;
 static int num = 1;
 char nombre[50] , version[10];

	strcpy(nombre , fich);
	if(copia != 0)
	{
		sprintf(version , ".%d" , num);
		strcat(nombre , version);
		++num;
	}
	if ( (fig = fopen(nombre , "wt")) == NULL)
	{
		printf("\aERROR: No puedo habrir el fichero '%s'.\n" , nombre);
		if (fichero == CIERTO) fprintf(accion , "ERROR: No puedo habrir el fichero '%s'.\n" , nombre);
		return (-1);
	}
#ifdef DEBUG
	printf("Abro el fichero '%s' para escribir las figuras\n" , nombre);
	if (fichero == CIERTO) fprintf(accion , "Abro el fichero '%s' para escribir las figuras\n" , nombre);
#endif
	fprintf(fig , "mapa %d %d\n" , mapa->di_maxx() , mapa->di_maxy());
	while(aux != NULL)
	{
		aux->escribir(fig);
		aux = aux->sig;
		++i;
	}
#ifdef DEBUG
	printf("Escribo las %d figuras del mundo\n" , i);
	if (fichero == CIERTO) fprintf(accion , "Escribo las %d figuras del mundo\n" , i);
#endif
	fclose(fig);
	return(0);
}

void recta::escribir(FILE *fig)
{
	fprintf(fig , "recta %d %d %d %d %d\n" , color , (int)a.di_x() , (int)a.di_y() , (int)b.di_x() , (int)b.di_y());
#ifdef DEBUG
	printf("Escribo la recta; x1 = %d y1 = %d x2 = %d y2 = %d\n" , (int)a.di_x() , (int)a.di_y() , (int)b.di_x() , (int)b.di_y());
	if (fichero == CIERTO) fprintf(accion , "Escribo la recta; x1 = %d y1 = %d x2 = %d y2 = %d\n" , (int)a.di_x() , (int)a.di_y() , (int)b.di_x() , (int)b.di_y());
#endif
}

void poligono::escribir(FILE *fig)
{
	fprintf(fig , "poligono %d %d %d %d %d" , color , (int)centro.di_x() , (int)centro.di_y() , grados(angulo) , n_lados);
	for(int j = 0 ; j < n_lados ; j++)
		fprintf(fig , " %d %d" , (int)puntos[j].di_dis() , grados(puntos[j].di_ang()) );
	fprintf(fig , "\n");
#ifdef DEBUG
	printf("Escribo el poligono; x = %d y = %d angulo = %d puntos %d\n" , (int)centro.di_x() , (int)centro.di_y() , grados(angulo) , n_lados);
	if (fichero == CIERTO) fprintf(accion , "Escribo el poligono; x = %d y = %d angulo = %d puntos %d\n" , (int)centro.di_x() , (int)centro.di_y() , grados(angulo) , n_lados);
#endif
}

void circulo::escribir(FILE *fig)
{
	fprintf(fig , "circulo %d %d %d %d\n" , color , (int)centro.di_x() , (int)centro.di_y() , radio);
#ifdef DEBUG
	printf("Escribo el circulo; x = %d y = %d radio = %d\n" , (int)centro.di_x() , (int)centro.di_y() , radio);
	if (fichero == CIERTO) fprintf(accion , "Escribo el circulo; x = %d y = %d radio = %d\n" , (int)centro.di_x() , (int)centro.di_y() , radio);
#endif
}
