/******************************************************************************\
*                                                                              *
*       MONITOR             Ignacio  Merino  Lagunilla                         *
*                                                                              *
*       Funciones para comunicar el mundo con los monitores mediante sockets.  *
*                                                                              *
*       22/febrero/1995                                                        *
\******************************************************************************/

#ifndef _MONITOR_
#define _MONITOR_

#include <stdio.h>

class monitor{
	private:
		int sock;
		int accesible;
		int activo;
		monitor *sig;
		monitor *ant;
	public:
		monitor(void);
		~monitor(void);
		inline int di_sock(void) { return(sock); }
		inline int di_accesible(void) { return(accesible); }
		inline monitor* di_ant(void) { return(ant); }
		inline monitor* di_sig(void) { return(sig); }
		inline void fijar_sock(int s) { sock = s; }
		int crear_primero(void);
		int crear(void);
		void destruir(int cerrar);
		int aceptar_nuevos(void);
		void responder_peticiones(void);
		int escribir_lista(char *fich , int copia);
		void terminar(void);
		void enviar_figura(void);
		char* di_datos(void);
		void parar_monitores(void);
		void continuar_monitores(void);
};

#endif
