/*       MENSAJE             Ignacio  Merino  Lagunilla                       */

#include <stdio.h>
#include <string.h>

#include "global.hpp"

//#define 	DEBUG


mensaje::mensaje(mensaje *&ini , mensaje *&fin , char *ori , char *dat)
{
	if(ini == NULL)
	{
		sig = ant = NULL;
		ini = fin = this;
	}
	else
	{
		sig = NULL;
		ant = fin;
		fin->fijar_sig(this);
		fin = this;
	}
	strcpy(origen , ori);
	strcpy(datos , dat);
#ifdef DEBUG
	printf("Se almacena el mensaje '%s' del robot '%s'\n" , datos , origen);
	if(fichero == CIERTO) fprintf(accion , "Se almacena el mensaje '%s' del robot '%s'\n" , datos , origen);
#endif
}

int mensaje::escribir(int copia)
{
 FILE *men;
 static int num = 1;
 char nombre[50] , version[10];
 mensaje *aux = this;

	sprintf(nombre , "mensajes.%s" , rob->di_nombre());
	if(copia != 0)
	{
		sprintf(version , ".%d" , num);
		strcat(nombre , version);
		++num;
	}
	if ( (men = fopen(nombre , "wt")) == NULL)
	{
		printf("\aERROR: No puedo habrir el fichero '%s'.\n" , nombre);
		if (fichero == CIERTO) fprintf(accion , "ERROR: No puedo habrir el fichero '%s'.\n" , nombre);
		return(-1);
	}
#ifdef DEBUG
	printf("Creo el fichero '%s' para escribir los mensajes\n" , nombre);
	if (fichero == CIERTO) fprintf(accion , "Creo el fichero '%s' para escribir los mensajes\n" , nombre);
#endif
	while(aux != NULL)
	{
		fprintf(men , "%s: %s\n" , aux->origen , aux->datos);
		aux = aux->sig;
	}
#ifdef DEBUG
	printf("Escribo los mensajes en el fichero '%s'\n" , nombre);
	if (fichero == CIERTO) fprintf(accion , "Escribo los mensajes en el fichero '%s'\n" , nombre);
#endif
	fclose(men);
	return(0);
}
