/******************************************************************************\
*                                                                              *
*       ROBOT_INFO          Ignacio  Merino  Lagunilla                         *
*                                                                              *
*       Funciones para gestionar la lista de los robots que conoce otro robot. *
*                                                                              *
*       22/febrero/1995                                                        *
\******************************************************************************/

#ifndef _ROBOT_INFO_
#define _ROBOT_INFO_

#include <stdio.h>

class robot_inf{
	private:
		char nombre[6];			// nombre del robot
		robot_inf *sig;
		robot_inf *ant;
	public:
		robot_inf(char *nom);
		inline ~robot_inf(void) { if(sig != NULL) delete(sig); }
		inline void fijar_sig(robot_inf *siguiente) { sig = siguiente; }
		inline void fijar_ant(robot_inf *anterior) { sig = anterior; }
		inline robot_inf* di_sig(void) { return(sig); }
		inline char* di_nombre(void) { return(nombre); }
		void borrar(char *nombre);
		int escribir(int copia);
};

#endif
