/******************************************************************************\
*                                                                              *
*       MENSAJE             Ignacio  Merino  Lagunilla                         *
*                                                                              *
*       Funciones para gestionar los mensajes que se intercambian los robots.  *
*                                                                              *
*       22/febrero/1995                                                        *
\******************************************************************************/

#ifndef _MENSAJE_
#define _MENSAJE_

#include <stdio.h>

class mensaje{
	private:
		char origen[6];			// robot que manda el mensaje
		char datos[50];			// datos del mensaje
		mensaje *sig;
		mensaje *ant;
	public:
		mensaje(mensaje *&ini , mensaje *&fin , char *origen , char *datos);
		inline ~mensaje(void) { if(sig != NULL) delete(sig); }
		inline void fijar_sig(mensaje *siguiente) { sig = siguiente; }
		int escribir(int copia);
};

#endif
